pcl::RSDEstimation< PointInT, PointNT, PointOutT > Class Template Reference
Module features

RSDEstimation estimates the Radius-based Surface Descriptor (minimal and maximal radius of the local surface's curves) for a given point cloud dataset containing points and normals. More...

`#include <pcl/features/rsd.h>`

Inheritance diagram for pcl::RSDEstimation< PointInT, PointNT, PointOutT >:

## Public Types

typedef Feature< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef Feature< PointInT, PointOutT >::PointCloudIn | PointCloudIn
typedef boost::shared_ptr< RSDEstimation< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const RSDEstimation< PointInT, PointNT, PointOutT > > | ConstPtr
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
typedef pcl::PointCloud< PointNT > | PointCloudN
typedef PointCloudN::Ptr | PointCloudNPtr
typedef PointCloudN::ConstPtr | PointCloudNConstPtr
typedef boost::shared_ptr< FeatureFromNormals< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const FeatureFromNormals< PointInT, PointNT, PointOutT > > | ConstPtr
Public Types inherited from pcl::Feature< PointInT, PointOutT >
typedef PCLBase< PointInT > | BaseClass
typedef boost::shared_ptr< Feature< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Feature< PointInT, PointOutT > > | ConstPtr
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(size_t, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, size_t index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| RSDEstimation ()
| Empty constructor. More...
void | setNrSubdivisions (int nr_subdiv)
| Set the number of subdivisions for the considered distance interval. More...
int | getNrSubdivisions () const
| Get the number of subdivisions for the considered distance interval. More...
void | setPlaneRadius (double plane_radius)
| Set the maximum radius, above which everything can be considered planar. More...
double | getPlaneRadius () const
| Get the maximum radius, above which everything can be considered planar. More...
void | setKSearch (int)
| Disables the setting of the number of k nearest neighbors to use for the feature estimation. More...
void | setSaveHistograms (bool save)
| Set whether the full distance-angle histograms should be saved. More...
bool | getSaveHistograms () const
| Returns whether the full distance-angle histograms are being saved. More...
boost::shared_ptr< std::vector< Eigen::MatrixXf, Eigen::aligned_allocator< Eigen::MatrixXf > > > | getHistograms () const
| Returns a pointer to the list of full distance-angle histograms for all points. More...
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
| FeatureFromNormals ()
| Empty constructor. More...
virtual | ~FeatureFromNormals ()
| Empty destructor. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeFeature (PointCloudOut &output)
| Estimate the estimates the Radius-based Surface Descriptor (RSD) at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

boost::shared_ptr< std::vector< Eigen::MatrixXf, Eigen::aligned_allocator< Eigen::MatrixXf > > > | histograms_
| The list of full distance-angle histograms for all points. More...
Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointNT, typename PointOutT>
class pcl::RSDEstimation< PointInT, PointNT, PointOutT >

RSDEstimation estimates the Radius-based Surface Descriptor (minimal and maximal radius of the local surface's curves) for a given point cloud dataset containing points and normals.

Note
  If you use this code in any academic work, please cite:

- Z.C. Marton , D. Pangercic , N. Blodow , J. Kleinehellefort, M. Beetz General 3D Modelling of Novel Objects from a Single View In Proceedings of the 2010 IEEE/RSJ International Conference on Intelligent Robots and Systems (IROS) Taipei, Taiwan, October 18-22, 2010
- Z.C. Marton, D. Pangercic, N. Blodow, Michael Beetz. Combined 2D-3D Categorization and Classification for Multimodal Perception Systems. In The International Journal of Robotics Research, Sage Publications pages 1378–1402, Volume 30, Number 11, September 2011.

Note
  The code is stateful as we do not expect this class to be multicore parallelized.

Author
  Zoltan-Csaba Marton

Definition at line 130 of file rsd.h.

## Member Typedef Documentation

template<typename PointInT , typename PointNT , typename PointOutT >

typedef boost::shared_ptr<const RSDEstimation<PointInT, PointNT, PointOutT> > pcl::RSDEstimation< PointInT, PointNT, PointOutT >::ConstPtr

Definition at line 145 of file rsd.h.

template<typename PointInT , typename PointNT , typename PointOutT >

typedef Feature<PointInT, PointOutT>::PointCloudIn pcl::RSDEstimation< PointInT, PointNT, PointOutT >::PointCloudIn

Definition at line 142 of file rsd.h.

template<typename PointInT , typename PointNT , typename PointOutT >

typedef Feature<PointInT, PointOutT>::PointCloudOut pcl::RSDEstimation< PointInT, PointNT, PointOutT >::PointCloudOut

Definition at line 141 of file rsd.h.

template<typename PointInT , typename PointNT , typename PointOutT >

typedef boost::shared_ptr<RSDEstimation<PointInT, PointNT, PointOutT> > pcl::RSDEstimation< PointInT, PointNT, PointOutT >::Ptr

Definition at line 144 of file rsd.h.

## Constructor & Destructor Documentation

template<typename PointInT , typename PointNT , typename PointOutT >

pcl::RSDEstimation< PointInT, PointNT, PointOutT >::RSDEstimation | ( |  | ) |

inline

Empty constructor.

Definition at line 149 of file rsd.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_.

## Member Function Documentation

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::RSDEstimation< PointInT, PointNT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

protected virtual

Estimate the estimates the Radius-based Surface Descriptor (RSD) at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()

Parameters

  output | the resultant point cloud model dataset that contains the RSD feature estimates (r_min and r_max values)

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 249 of file rsd.hpp.

References pcl::computeRSD(), pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

Referenced by pcl::RSDEstimation< PointInT, PointNT, PointOutT >::getHistograms().

template<typename PointInT , typename PointNT , typename PointOutT >

boost::shared_ptr<std::vector<Eigen::MatrixXf, Eigen::aligned_allocator<Eigen::MatrixXf> > > pcl::RSDEstimation< PointInT, PointNT, PointOutT >::getHistograms | ( |  | ) | const

inline

Returns a pointer to the list of full distance-angle histograms for all points.

Definition at line 196 of file rsd.h.

References pcl::RSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), and pcl::RSDEstimation< PointInT, PointNT, PointOutT >::histograms_.

template<typename PointInT , typename PointNT , typename PointOutT >

int pcl::RSDEstimation< PointInT, PointNT, PointOutT >::getNrSubdivisions | ( |  | ) | const

inline

Get the number of subdivisions for the considered distance interval.

Definition at line 162 of file rsd.h.

template<typename PointInT , typename PointNT , typename PointOutT >

double pcl::RSDEstimation< PointInT, PointNT, PointOutT >::getPlaneRadius | ( |  | ) | const

inline

Get the maximum radius, above which everything can be considered planar.

Definition at line 174 of file rsd.h.

template<typename PointInT , typename PointNT , typename PointOutT >

bool pcl::RSDEstimation< PointInT, PointNT, PointOutT >::getSaveHistograms | ( |  | ) | const

inline

Returns whether the full distance-angle histograms are being saved.

Definition at line 192 of file rsd.h.

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::RSDEstimation< PointInT, PointNT, PointOutT >::setKSearch | ( | int |  | ) |

inline

Disables the setting of the number of k nearest neighbors to use for the feature estimation.

Definition at line 178 of file rsd.h.

References pcl::Feature< PointInT, PointOutT >::getClassName().

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::RSDEstimation< PointInT, PointNT, PointOutT >::setNrSubdivisions | ( | int | nr_subdiv | ) |

inline

Set the number of subdivisions for the considered distance interval.

Parameters

  [in] | nr_subdiv | the number of subdivisions

Definition at line 158 of file rsd.h.

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::RSDEstimation< PointInT, PointNT, PointOutT >::setPlaneRadius | ( | double | plane_radius | ) |

inline

Set the maximum radius, above which everything can be considered planar.

Note
  the order of magnitude should be around 10-20 times the search radius (0.2 works well for typical datasets).
  on accurate 3D data (e.g. openni sernsors) a search radius as low as 0.01 still gives good results.

Parameters

  [in] | plane_radius | the new plane radius

Definition at line 170 of file rsd.h.

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::RSDEstimation< PointInT, PointNT, PointOutT >::setSaveHistograms | ( | bool | save | ) |

inline

Set whether the full distance-angle histograms should be saved.

Note
  Obtain the list of histograms by getHistograms ()

Parameters

  [in] | save | set to true if histograms should be saved

Definition at line 188 of file rsd.h.

References pcl::io::save().

## Member Data Documentation

template<typename PointInT , typename PointNT , typename PointOutT >

boost::shared_ptr<std::vector<Eigen::MatrixXf, Eigen::aligned_allocator<Eigen::MatrixXf> > > pcl::RSDEstimation< PointInT, PointNT, PointOutT >::histograms_

protected

The list of full distance-angle histograms for all points.

Definition at line 209 of file rsd.h.

Referenced by pcl::RSDEstimation< PointInT, PointNT, PointOutT >::getHistograms().

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/rsd.h
- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/impl/rsd.hpp